#ifndef APPLYCHANGESWIZARD_H
#define APPLYCHANGESWIZARD_H

#include <QWizard>

#include "package.h"

namespace Ui {
class ApplyChangesWizard;
}

class ApplyChangesWizard : public QWizard
{
    Q_OBJECT

public:
    explicit ApplyChangesWizard(const QString& sdkPath, const QList<Package>& uninstall, const QList<Package>& install, QWidget *parent = 0);
    ~ApplyChangesWizard();

    void closeEvent(QCloseEvent* e); // overridden
    void keyPressEvent(QKeyEvent *evt); // overridden

    bool isOperationInProgress();

private slots:
    void on_ApplyChangesWizard_currentIdChanged(int id);

    void on_acceptCheck_stateChanged(int arg1);

private:
    void nextOperation();
    void sdkCommand(QStringList args);
    void processFailure(QString error);

    Ui::ApplyChangesWizard *ui;

    QList<Package> uninstall;
    QList<Package> install;
    QString sdkPath;
    int operationIdx;
};

#endif // APPLYCHANGESWIZARD_H
