#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QFileIconProvider>
#include <QTreeWidgetItem>
#include <functional>

#include "package.h"

struct QLabel;

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();

    void rescan();

    void setSDKPath(QString path);

private slots:
    void on_actionChoose_SDK_triggered();

    void on_actionRescan_triggered();

    void on_actionE_xit_triggered();

    void on_actionExpand_all_triggered();

    void on_actionCollapse_all_triggered();

    void on_actionApply_changes_triggered();

    void on_actionAbout_qsdkmanager_triggered();

    void on_actionAbout_Qt_triggered();

    void on_actionCurrent_triggered();

    void on_actionAll_triggered();

    void on_actionNone_triggered();

    void on_actionInclude_obsolete_packages_triggered();

    void on_actionStable_triggered();

    void on_actionBeta_triggered();

    void on_actionDev_triggered();

    void on_actionCanary_triggered();

    void on_actionHomepage_triggered();

private:
    void refreshListFromOutput(QByteArray o);
    void addPackage(int packageIdx, const Package& p);
    void updateUIState(int state);
    void visitPackages(QTreeWidgetItem* root, std::function<void(QTreeWidgetItem*)> cb);
    void setChannel(int c);

    Ui::MainWindow *ui;
    QLabel *statusLabel;
    int channel;

    QFileIconProvider iconProvider;

    QString currentSDKPath;
    QList<Package> lastScan;
};

#endif // MAINWINDOW_H
