#ifndef UNIFY_H
#define UNIFY_H

#include <QTreeWidget>

class Unify {
public:
    virtual ~Unify() {}
    virtual int childCount() = 0;
    virtual QTreeWidgetItem* childAt(int i) = 0;
    virtual void addChild(QTreeWidgetItem *i) = 0;
};

class UnifyItem : public Unify {
    QTreeWidgetItem* itm;
public:
    UnifyItem(QTreeWidgetItem *itm) : itm(itm) {}
    int childCount() {
        return itm->childCount();
    }
    QTreeWidgetItem* childAt(int i) {
        return itm->child(i);
    }
    void addChild(QTreeWidgetItem *i) {
        itm->addChild(i);
    }
};

class UnifyWidget : public Unify {
    QTreeWidget* itm;
public:
    UnifyWidget(QTreeWidget* itm) : itm(itm) {}
    int childCount() {
        return itm->topLevelItemCount();
    }
    QTreeWidgetItem* childAt(int i) {
        return itm->topLevelItem(i);
    }
    void addChild(QTreeWidgetItem *i) {
        itm->addTopLevelItem(i);
    }
};

#endif // UNIFY_H
